from rocolib.api.components.Component import Component

c = Component()

# BOX

c.addSubcomponent("cabin","Cabin", inherit=True, prefix=None)
c.addSubcomponent("port","BoatBase", root=True)
c.addSubcomponent("star","BoatBase")

c.addConstraint(("port","boat.length"), ("length", "depth"), "sum(x)")
c.addConstraint(("port","boat.width"), "width", "x/4.")
c.addConstraint(("port","boat.depth"), ("length", "depth"), "sum(x)/20.")
c.addConstraint(("port","bow.point"), "length", "x/2.")
c.addConstraint(("port","stern.point"), "length", "x/8.")

c.addConstraint(("star","boat.length"), ("length", "depth"), "sum(x)")
c.addConstraint(("star","boat.width"), "width", "x/4.")
c.addConstraint(("star","boat.depth"), ("length", "depth"), "sum(x)/20.")
c.addConstraint(("star","bow.point"), "length", "x/2.")
c.addConstraint(("star","stern.point"), "length", "x/8.")

c.addConnection(("cabin", "portedge"), ("port", "portedge"))
c.addConnection(("cabin", "staredge"), ("star", "staredge"))

c.inheritInterface("foreedge", ("cabin", "foreedge"))
c.inheritInterface("rearedge", ("cabin", "rearedge"))
c.inheritInterface("portedge", ("port", "staredge"))
c.inheritInterface("staredge", ("star", "portedge"))

c.toLibrary("Catamaran")
